/******************************************************************************
 * task.c
 * This file is part of "Assignment 2: Memory Management" 
 * Copyright (C) 2009 - c506001 (email: c506001@cse.hcmut.edu.vn )
 *
 * Content:
 * -------- 
 * Implementation of data structure-related & file-related functions
 *
 * System and Networking Department
 * Faculty of Computer Science and Engineering
 * Ho Chi Minh City University of Technology
 ******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

/**
 * Function name: freeFrameList
 * Description:
 *    Free FrameList's memory
 * Return value:
 *    SUCCESS: If successful
 **/
int freeFrameList(struct FrameList *frames){
  //TODO: Free frame list's memory
  
  return SUCCESS;
}


/**
 * Function name: freeFreeFrameList
 * Description:
 *    Free FreeFrameList's memory
 * Return value:
 *    SUCCESS: If successful
 **/
int freeFreeFrameList(struct FreeFrameList *freeframes){
  //TODO: Free free frame list's memory
  
  return SUCCESS;
}


/**
 * Function name: freeProcess
 * Description:
 *    Free Process's memory
 * Return value:
 *    SUCCESS: If successful
 **/
int freeProcess(struct Process* p)
{
  //TODO: free process's memory
  
  return SUCCESS;
}


/**
 * Function name: freeProcessList
 * Description:
 *    Free ProcessList's memory
 * Return value:
 *    SUCCESS: If successful
 **/
int freeProcessList(struct ProcessList *procs){
  //TODO: free all processes of process list
  //      free process list's memory
  
  return SUCCESS;
}


/**
 * Function name: freeRequestList
 * Description:
 *    Free RequestList's memory
 * Return value:
 *    SUCCESS: If successful
 **/
int freeRequestList(struct RequestList *reqs)
{
  //TODO: free all requests of list
  //      free request list's memory
    
  return SUCCESS;
}


/**
 * Function name: freeSystem
 * Description:
 *    Free System's memory
 * Return value:
 *    SUCCESS: If scucessful
 **/
int freeSystem(struct System *s)
{
  //TODO: free frame list
  //      free free frame list
  //      free process list    
  
  return SUCCESS;
}


/**
 * Function name: removeFirstRequest
 * Description:
 *    Remove the first request out of RequestList
 * Return value:
 *    First request: If successful
 *    NULL         : If RequestList is NULL or empty
 **/
struct Request* removeFirstRequest(struct RequestList *reqs)
{
  if (!reqs || reqs->list == NULL)
    return NULL;

  struct Request *first=reqs->list;
  reqs->list=first->next;

  return first;
}


/**
 * Function name: addTailRequestList
 * Prerequisite:
 *    Request r is not NULL
 * Description:
 *    Add a new Request to the tail of RequestList
 * Return value:
 *    0               : If successful
 *    ERR_REQLIST_NULL: If RequestList is NULL
 **/
int addTailRequestList(struct RequestList *reqs, struct Request *r)
{
  //TODO: add request r to tail of request list

  return 0;
}


/**
 * Function name: getFreeFrame
 * Description:
 *    Get the free frame no. pointed by the first elem in FreeFrameList
 *    Remove the first elem in FreeFrameList
 * Return value:
 *    No. of free frame      : If successful
 *    ERR_FREEFRAMELIST_NULL : If FreeFrameList is NULL
 *    ERR_FREEFRAMELIST_EMPTY: If FreeFrameList is empty
 **/
int getFreeFrame(struct FreeFrameList *freeframes)
{
  //TODO: get first free frame in free frame list
  //      remove it out of free frame list

  return first->no;
}


/**
 * Function name: addTailFreeFrameList
 * Description:
 *     Add a new FreeFrame to the tail of FreeFrameList
 * Return value:
 *    0                     : If successful
 *    ERR_FREEFRAMELIST_NULL: If FreeFrameList is NULL
 **/
int addTailFreeFrameList(struct FreeFrameList *freeframes, struct FreeFrame *ff)
{
  //TODO: add free frame ff to tail of free frame list
  
  return 0;
}


/**
 * Function name: addToProcessList
 * Prerequisite:
 *    Process p is not NULL
 *    Process p is not in ProcessList procs
 * Description:
 *    Add Process p to ProcessList procs in order of its pid
 * Return value:
 *    SUCCESS           : If successful
 *    ERR_PROCLIST_NULL : If ProcessList is NULL
 **/
int addToProcessList(struct ProcessList *procs, struct Process *p)
{
  //TODO: add process p to process list in order of its pid

  return SUCCESS;
}


/**
 * Function name: delProcessOutOfList
 * Prerequisite:
 *    Process p is an entry of ProcessList procs
 * Description:
 *    Remove Process p out of ProcessList procs
 * Return value:
 *    SUCCESS           : If successful
 *    ERR_PROCLIST_NULL : If ProcessList is NULL
 *    ERR_PROCLIST_EMPTY: If ProcessList is empty
 **/
int delProcessOutOfList(struct ProcessList *procs, struct Process *p)
{
  //TODO: remove process p out of process list
  //      free process' memory
  
  return SUCCESS;
}
