/******************************************************************************
 * mem.c
 * This file is part of "Assignment 2: Memory Management" 
 * Copyright (C) 2009 - c506001 (email: c506001@cse.hcmut.edu.vn )
 *
 * Content:
 * -------- 
 * Functions of memory management
 *
 * System and Networking Department
 * Faculty of Computer Science and Engineering
 * Ho Chi Minh City University of Technology
 ******************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "memop.h"


char output[1024];

/**
 * Function name: initSectionTable
 * Prerequisite:
 *    stbl is not NULL
 * Description:
 *    Initialize section table and its page tables
 * Return value:
 *    SUCCESS          : If successful
 *    ERR_MALLOC_FAILED: If can not malloc memory
 **/
static int initSectionTable(struct SectionTable *stbl){
  //TODO: initialize section table and its page tables
  
  return SUCCESS;
}


/**
 * Function name: getProcess
 * Prerequisite:
 *    sys is not NULL;
 * Description:
 *    Traverse ProcessList of System to retrieve process with its pid is pid
 * Return value:
 *    struct Process: If its pid is pid
 *    NULL          : If there is no process pid in sys
 **/
static struct Process* getProcess(struct System *sys, int pid)
{
  //TODO: get process pid in process list of system

  return NULL;
}


/**
 * Function name: createProcess
 * Description:
 *    Create a struct Process to add to ProcessList of System
 * Return value:
 *    struct Process: If successful
 *    NULL          : If failure
 **/
static struct Process* createProcess(int pid, int size)
{
  //TODO: create struct process

  return tmp;
}


/**
 * Function name: addToPageTable
 * Prerequisite:
 *    sys is not NULL
 * Description:
 *    Add free frame ff to page table of process pid in System
 *    Map page p corresponding to frame ff
 * Return value:
 *    SUCCESS              : If successful
 *    ERR_OUT_OF_RANGE     : If page number is greater than its upper bound
 *    ERR_GETPROCESS_FAILED: If can not get Process pid in ProcessList of System
 **/
static int addToPageTable(struct System *sys, int pid, int p, int ff)
{
  //TODO: update frame information to store pid and pageno. of process referring to it
  //      update page information to point to frame it is referring to

  return SUCCESS;
}


/**
 * Function name: chooseVictimFrame
 * Description:
 *    All frames in system have been used
 *    Traverse FrameList frames to select victim frame
 *    Store that frame to Frame frame
 *    Update the next frame to start to traverse
 * Return value:
 *    no. of victim frame: If successful
 *    ERR_FRAMELIST_NULL : If FrameList is NULL
 **/
int chooseVictimFrame(struct FrameList *frames, struct Frame **frame)
{
  //TODO: choose victim frame and store it to *frame
  //      use LRU algorithm

  return fno;
}

/**
 * Function name: updatePageTable
 * Prerequisite:
 *    sys is not NULL
 *    All frames in main memory have been allocated to processeses
 *    Physical address addr is in page p of process pid
 * Description:
 *    Preempt a victim frame and allocate it to page p of process pid
 *    Update information about changes
 * Return value:
 *    SUCCESS              : If successful
 *    ERR_OUT_OF_RANGE     : If page number is greater than its upper bound
 *    ERR_GETPROCESS_FAILED: If can not get Process pid in ProcessList of System
 **/
static int updatePageTable(struct System *sys, int pid, int p, int addr)
{
  //TODO: choose victim frame
  //TODO: update state of page previously referring to this frame to be invalid
  //TODO: update frame information to store pid and pageno. of process referring to it
  //TODO: update page information to point to frame it is referring to

  return SUCCESS;
}


/**
 * Function name: allowAccess
 * Prerequisite:
 *    proc is not NULL
 * Description:
 *    Check whether Process proc has permission to access Address addr
 * Return value:
 *    TRUE : If addr is valid
 *    FALSE: If addr is invalid
 **/
static bool allowAccess(struct Process *proc, int addr)
{
  //TODO: check whether this address is valid or not
      
  return TRUE;
}


/**
 * Function name: freeMemory
 * Prerequisite:
 *    sys and proc are not NULL
 * Description:
 *    Free all memory held by Process proc
 *    Free Process proc
 * Return value:
 *    SUCCESS          : If successful
 *    ERR_MALLOC_FAILED: If can not malloc memory
 **/
static int freeMemory(struct System *sys, struct Process *proc)
{
  //TODO: swap out content of all frames being referred by this process to backing store
  //      set states of these frames to free (not inuse)
  //      free process
  
  return SUCCESS;
}


/**
 * Function name: allocFrames
 * Description:
 *    Allocate memory for process
 * Return value:
 *    SUCCESS                 : If successful
 *    ERR_SYSTEM_NULL         : If System is NULL
 *    ERR_PROCESS_EXISTS      : If process pid has existed
 *    ERR_CREATEPROCESS_FAILED: If can not create new struct Process
 *    ERR_ADDPROCESS_FAILED   : If can not add a Process to ProcessList
 **/
int allocFrames(struct System *sys, int pid, int size, char **outstr)
{
  if (!sys)
    return ERR_SYSTEM_NULL;

  //TODO: create struct process pid
  //      add thhat process to ProcessList of System
  //      allocate frames to this process
  //free frames are allocated first

  return SUCCESS;
}


/**
 * Function name: accessAddress
 * Description:
 *    Process pid accesses address addr
 * Return value:
 *    SUCCESS             : If sucessful
 *    ERR_SYSTEM_NULL     : If System is NULL
 *    ERR_PROCESS_NOTEXIST: If process pid has not existed
 *    ERR_INVALID_ADDRESS : If address is invalid
 **/
int accessAddress(struct System *sys, int pid, int addr, char **outstr)
{
  if (!sys)
    return ERR_SYSTEM_NULL;

  //TODO: check whether process pid exists
  //      check whether accessed address is valid
  //      check whether addr is in an invalid page
  //      calculate physical address from its logical one & access it
  
  return SUCCESS;
}


/**
 * Function name: finishProcess
 * Description:
 *    Free all frames referred by process pid
 * Return value:
 *    SUCCESS             : If successful
 *    ERR_SYSTEM_NULL     : If System is NULL
 *    ERR_PROCESS_NOTEXIST: If process pid has not existed
 **/
int finishProcess(struct System *sys, int pid, char **outstr)
{
  if (!sys)
    return ERR_SYSTEM_NULL;

  // check whether process pid exists
  // free frames referred by process pid

  return SUCCESS;
}
